import React from 'react';
import ReactDOM from 'react-dom';
import NAV from './nav'
import BARCHART from './bar'
import GLOBAL from  './global'
import COUNTRIES from  './countries'
import CANVAS from './canvas'

import AXIS from './axis'

class App extends React.Component{

  
   constructor(){
     super()
     this.state = {
      data: null,
      loaded: false,
      date: null,
      nav: null
    };
     this.svg = React.createRef();
     this.margin = React.createRef();
     
   }
  
    componentDidMount(){
      console.log('svg',this.svg,this.margin)
    }
  
   heading(){
     return 'Covid DashBoard';
   }
  
   pageRender(nav){
     switch(this.state.navs){
          case 'Global':
               console.log(this.state.navs)
              return <GLOBAL data ={ this.state.data[this.state.navs] } />;
          case 'Countries':
              return <COUNTRIES data ={ this.state.data[this.state.navs] } />;
          case undefined:
              return <h9>Svg Visualization to be loaded here</h9>;
      }
   }
  
  
   navigation(nav){
     this.setState({navs:nav})
   }
  
  
   async requestCovid(){
     var requestOptions = {
  				method: 'GET',
          redirect:'follow',
          mode: 'no-cors',
				};
     const result =  await fetch("https://api.covid19api.com/summary")
     return result.text();
   }
  
  
   render(){
     let date = null
     return (
       <div class ="container">
         <div class="row">
         <div class="col s9 push-s3"><h2>{ this.heading() }</h2></div>
         <div class="col s3"><button onClick = {()=>{    
               alert('Loading Covid Data');
               this.requestCovid().then(result=>{
               result = JSON.parse(result)
               let date = result.Date
               delete result.Date
               console.log(result)
               let navs = Object.keys(result)
               this.setState({'data': result,
                              'loaded':true,
                             'date': date,
                              'navs':navs[0]
                              })
              }) 
              console.log(this.requestCovid())
                                                    }}
           class="waves-effect btn waves-light"> 
           {this.state.loaded?'Refresh Data':'Load Data'}</button></div> 
           <div class="col s12">
           		<NAV data ={this.state.data? Object.keys(this.state.data): ['data','loading'] } 
                   onclick = {(nav) => this.navigation(nav)}
                />
           </div> 
        </div>
          <div class = "container">
              <div class="row">
              <label> { this.state.navs }  Data Generated on: { this.state.date ? this.state.date :'NILL' } </label>
              </div> 
                {    
                  this.pageRender(this.state.nav)
                } 
              <div class="row">
                   <CANVAS  height = '100' width = '100'
                      children = {[
                         <text x = '5' y = '25' >Hello World</text>,
                         <AXIS></AXIS>
                        ]} >
                   </CANVAS>
              </div>   
          </div>
      </div> 
       
     );
   }
  
}

export default App