import React from 'react';

class BARCHART extends React.Component{
  
     constructor(props){
        super(props);
        this.renderD3Component = this.renderD3Component.bind(this)
     }
  
     renderD3Component(){
       const draw =  BarChartComponent(this.node,{'max':this.props.max})
       draw(this.props.data)
     }
  
     componentDidMount(){
        this.renderD3Component()
      }
  
     componentDidUpdate(){
        this.renderD3Component()
      }
  
     render(){
       return (
           <svg height = {this.props.height} width = {this.props.width} ref = { node => this.node = node }>
             <g transform="translate(80,0)" ></g>
           </svg>
       );
      
     }
}
export default BARCHART

import { select, 
        arc,
        csv,
        scaleLinear,
        max,
        scaleBand,
        axisLeft,
        axisBottom,
        format,
        sum
       
       } from 'd3'

const BarChartComponent = (selection,props) => {
      
    const render = (data) =>{
      drawChart(data)
    }
    
    const drawChart = (data)=>{
         
         selection = select(selection)
      
         const height = selection.attr('height')
         const width = selection.attr('width')
         
         selection = selection.select('g')
      
         const margin = { left:80,right:80,top:40,bottom:40}
         const innerWidth = width - margin.left - margin.right;
         const innerHeight = height - margin.top - margin.bottom;
      

         const xValue = d => d.value
         const yValue = d => d.label
      			
         const xScale = scaleLinear()
                        .domain([0,max(data,xValue)])
                        .range([0,innerWidth])
                        .nice();
      
         console.log('max for chart',max(data,xValue))
  
         const yScale = scaleBand().domain(data.map(yValue))
                                    .range([0,innerHeight])
                                    .padding(0.3);
      
         const xFormat = x => { return format("0.2s")(x)  } ;
  
         const yaxis = axisLeft(yScale); 
  
         const xaxis = axisBottom(xScale).tickFormat(xFormat);
      
         const axi = selection.selectAll('g').data([sum(data.map(d=>d.value))])
      
         const axisEnter = axi.enter()
         
  
         axisEnter.append('g')
                  .call(yaxis)
      
         axisEnter.append('g')
                  .call(xaxis) 
                  .attr('transform',`translate(0,${innerHeight})`)
    
      
         selection.selectAll('rect')
           .data(data)
           .enter()
           .append('rect')
           .attr('height',yScale.bandwidth())
           .attr('y', d => yScale(d.label) )
           .style('fill','steelblue')
           .merge(selection.selectAll('rect').data(data))
           .transition().delay(500)
           .attr('width', d => { return xScale(d.value)  } )
      
     }
    
    return render;
 }

