import React from 'react';
import BARCHART from './bar'

import { select,selectAll
       } 
from 'd3'; 

class COUNTRIES extends React.Component{

    constructor(props){
      super(props)
      this.renderD3Component = this.renderD3Component.bind(this)
      this.state = { 'chart1':null,'chart2':null }
    }
  
    renderD3Component(){
       const selection = select(this.node)
       const option = d => {  let op = d.Country  === undefined ?  -1:d.Country ; return op; }
       const optionText = d => { let op =  d.Country  === undefined ? 'Select a country':d.Country ; return op; }
       this.props.data.push({'default':'Select a option'})
       
       console.log('countries',this.props.data)
       const options = selection.selectAll('option').data(this.props.data)
       const opt = options.enter().append('option')
       opt.merge(options).attr('value',option)
          .text(optionText)
      
       selectAll("option[value='-1']").attr('selected','').attr('disabled','')
   
    }
  
    componentDidMount(){
        this.renderD3Component()
        M.FormSelect.init(this.node, this.node.childNodes);
    }
  
    componentDidUpdate(){
        this.renderD3Component()
    }
  
    renderCharts(barChartData){
        if(this.state.chart1 !== null){
           return (
             <div class="col s12">
               <BARCHART data = {barChartData} height = "500" width ="500"/>
             </div> 
           );
        }
    }
  
  
    render(){
       console.log(M)
       let sel,data_,barChart1Data,barChart2Data;
       return (
            <div class = "row">
                <div class="input-field col s5 push-s7">
                  <select ref = { node => this.node = node } onChange = { (s) => 
                          { 
                            console.log(s.target.value)
                            //this.setState({ 'select':s.target.value })
                            sel = this.props.data.filter(d=>d.Country == s.target.value )
                            sel = sel[0]
                            console.log('selection',sel)
                            let data_ = []
                            const labels = Object.keys(sel)
                            const values = Object.values(sel)
                            for(let i = 0;i<labels.length;i++){
                              let pair = {}
                              pair['label'] = labels[i]
                              pair['value'] = +values[i]
                              data_.push(pair)
                            }  
                  
                            console.log('data_',data_)
                  
                            let barChart1 = ['NewConfirmed','NewDeaths','NewRecovered']
                            let barChart2 = ['TotalConfirmed','TotalDeaths','TotalRecovered']
                            barChart1Data = data_.filter( d=> {
                                                       return barChart1.includes(d.label)
                                                     })

                            barChart2Data = data_.filter( d=> {
                                                       return barChart2.includes(d.label)
                                                     })
                            console.log('data chart 1',barChart1Data)
                            console.log('data chart 2',barChart2Data)
                            this.setState({'chart1':barChart1Data,'chart2':barChart2Data })
                         
                            
                          } } >
                  </select>
                </div>
                 { this.renderCharts(this.state.chart1) }
                 { this.renderCharts(this.state.chart2) }
             </div>
       );
    }
    
}

export default COUNTRIES